/****************************************************************/
/**                                                            **/
/**                         CORRELAC.C                         **/
/**                                                            **/
/**    Calculates  linear correlation                          **/
/**                                                            **/
/**                                   Annibal Hetem Junior     **/
/**                                         31/03/93           **/
/**                                                            **/
/****************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>
 
/*****************************************************************/
/**          aliases                                            **/
/*****************************************************************/

#define real double
#define sqr(x) ((x)*(x))

/*****************************************************************/
/**          global variables and types                         **/
/*****************************************************************/

char lx=0,ly=0;
double soma_x=0, soma_y=0, soma_x2=0, soma_xy=0, soma_y2=0;
double slope,intercept,delta_slope,delta_intercept,r2;
double N_x=0;

/***************************************************************/

LerDados( N,logx,logy )
char *N;
int logx,logy;
{
  FILE *T;
  double X,Y;
  float ix,iy;

  printf ("-> LerDados\n");
  T = fopen ( N,"r" );
  do {
    ix = -1;
    fscanf(T,"%g%g",&ix,&iy);

    if (ix > 0) {
      X = (real)ix;  Y = (real)iy;

      if (logx) X=log10(X);
      if (logy) Y=log10(Y);

      soma_x += X;
      soma_y += Y;
      soma_x2 += sqr(X);
      soma_y2 += sqr(Y);
      soma_xy += (X*Y);
      N_x += (real)1;

      printf("%g %g\n",X,Y);
    } 
  }  while (! feof(T));

  fclose(T);
}

GravarDados()
{
  printf( "y = ax + b\n" );
  printf( "a = %g (%g)\n",slope,delta_slope);
  printf( "b = %g (%g)\n",intercept,delta_intercept);
  printf( "r2 = %g\n",r2);
  printf( "n = %g\n",N_x);
}

Straight_Line()
{
  double delta,s2;

  printf("correlacao...\n");
  r2 = sqr ( N_x * soma_xy - soma_x * soma_y ) /
	 ( ( N_x * soma_x2 - sqr ( soma_x ) ) *
	   ( N_x * soma_y2 - sqr ( soma_y ) ) );
  delta = N_x * soma_x2 - sqr(soma_x);

  intercept = ( soma_x2*soma_y - soma_x*soma_xy ) / delta;
  slope = ( N_x*soma_xy - soma_x*soma_y ) /delta;

  s2 = (1/(N_x-2)) *
       ( soma_y2 + N_x*sqr(intercept) + sqr(slope)*soma_x2 -
       2*(intercept*soma_y - slope*intercept*soma_x + slope*soma_xy) );
  delta_slope = sqrt ( N_x*s2 / delta );
  delta_intercept = sqrt ( s2*soma_x2 / delta );

  return;
}

/*****************************************************************/
/**          main procedure                                     **/
/*****************************************************************/
 
main (argc,argv)
int argc;
char *argv[];
{
  int i,lx=0,ly=0;

  if (argc < 2) {
               printf ( "Missing arguments: %s file [options]\n",argv[0] );
               printf ( "options are: x, y for log(x) and/or log(y)\n"); 
               return;
             }

  for (i=2; i<argc; i++) {
    if (*argv[i] == 'x') lx = -1;
    if (*argv[i] == 'y') ly = -1;
  }

  printf ( "*** Correlac ***\n" );
  printf ( "file: %s\n",argv[1] );
  if (lx) printf("X -> log10\n");
  if (ly) printf("Y -> log10\n");

  LerDados(argv[1],lx,ly);
  Straight_Line();
  GravarDados();
}
