/****************************************************************/
/**                                                            **/
/**                         FRACTDIM.C                         **/
/**                                                            **/
/**    Calculates fractal dimension                            **/
/**                                                            **/
/**                                   Annibal Hetem Junior     **/
/**                                         31/03/93           **/
/**                                                            **/
/****************************************************************/

#include <stdio.h>
#include <math.h>
 
/*****************************************************************/
/**          aliases                                            **/
/*****************************************************************/

#define real double
#define sqr(x) ((x)*(x))

/*****************************************************************/
/**          global variables and types                         **/
/*****************************************************************/

char lx=0,ly=0;
real soma_x=0, soma_y=0, soma_x2=0, soma_xy=0, soma_y2=0;
real slope,intercept,delta_slope,delta_intercept,r2;
real N_x=0;

/***************************************************************/

LerDados( N )
char *N;
{
  FILE *T;
  real X,Y;
  int ix,iy;

  T = fopen ( N,"r" );
  do {
    ix = -1;
    fscanf(T,"%d%d",&ix,&iy);

    if (ix > 0) {
      X = log10((real)ix);  
      Y = log10((real)iy);
      soma_x += X;
      soma_y += Y;
      soma_x2 += sqr(X);
      soma_y2 += sqr(Y);
      soma_xy += (X*Y);
      N_x += (real)1;
    } 
  }  while (! feof(T));
  fclose(T);
}

GravarDados( n )
char *n;
{
  real D,DD,K,DK,dez;
  char *i,*j,*a="                                             ";
  FILE *f;

  dez = (real) 10;

  D = 2 * slope;
  DD = 2 * delta_slope;

  K = pow ( dez, (-intercept / D) );
  DK = log(dez) * K * delta_intercept / D;

  for(i=n,j=a; *i; *j++ = *i++);
  for(i=a; (*i) && (*i != '.'); i++);
  *i++ = '.'; *i++ = 's'; *i++ = 't'; *i++ = 't'; *i=0;

  printf ("appending [%s]\n",a );

  printf( "D = %f (%f)\n",D,DD);
  printf( "K = %f (%f)\n",K,DK);
  printf( "r2 = %f\n",r2);
  printf( "n = %.0f\n",N_x);

  f = fopen ( a,"a" );

  fprintf( f,"D       %f (%f)\n",D,DD);
  fprintf( f,"K       %f (%f)\n",K,DK);
  fprintf( f,"r2      %f\n",r2);

  fclose(f);
}

Straight_Line()
{
  real delta,s2;

  r2 = sqr ( N_x * soma_xy - soma_x * soma_y ) /
	 ( ( N_x * soma_x2 - sqr ( soma_x ) ) *
	   ( N_x * soma_y2 - sqr ( soma_y ) ) );
  delta = N_x * soma_x2 - sqr(soma_x);

  intercept = ( soma_x2*soma_y - soma_x*soma_xy ) / delta;
  slope = ( N_x*soma_xy - soma_x*soma_y ) /delta;

  s2 = (1/(N_x-2)) *
       ( soma_y2 + N_x*sqr(intercept) + sqr(slope)*soma_x2 -
       2*(intercept*soma_y - slope*intercept*soma_x + slope*soma_xy) );
  delta_slope = sqrt ( N_x*s2 / delta );
  delta_intercept = sqrt ( s2*soma_x2 / delta );

  return;
}

/*****************************************************************/
/**          main procedure                                     **/
/*****************************************************************/
 
main (argc,argv)
int argc;
char *argv[];
{
  if (argc < 2) {
               printf ( "Missing arguments: %s file\n",argv[0] );
               return;
             }

  printf ( "*** FractDim ***\n" );
  printf ( "file: %s\n",argv[1] );

  LerDados(argv[1]);
  Straight_Line();
  GravarDados(argv[1]);
}
