/***************************************************************/
/*                                                             */
/*                   ---  PERIAREA.C  ---                      */
/*                                                             */
/* Calcula area e perimetro de nuvem fractal                   */
/*                                                             */
/*                                                             */
/*     Annibal Hetem Junior                      07/02/93      */
/*                                                             */
/***************************************************************/

#include <stdio.h>
#include <math.h>

#define FREE   14
#define GOTTEN 13
#define AREA   12
#define PERIM  11

#define MAXS   128
#define real   double

typedef int T_Ponto[2];

unsigned int Area,Perimetro,NPontos=0;
T_Ponto LimTudo[2],LimNuvem[2];
unsigned char pixel[MAXS][MAXS];
real proj [MAXS][MAXS];
real maximum=-1e30, minimum=1e30;
char *Entrada,*Saida="                                             ";
FILE *periarea;

#define max(a,b) (((a)>(b))?(a):(b))
#define min(a,b) (((a)<(b))?(a):(b))

LerDados( N )
char *N;
{
  FILE *T;
  int X,Y,I;
  real M;

  for(I=0;I<=1;I++) { LimTudo[0][I] = 32000; LimTudo[1][I] = -32000; }
  T = fopen ( N,"r" );
  while (!feof(T)) {
    fscanf ( T,"%d%d%E",&X,&Y,&M );
    proj[X][Y] = M;
    LimTudo[0][0] = min ( LimTudo[0][0],X );
    LimTudo[0][1] = min ( LimTudo[0][1],Y );
    LimTudo[1][0] = max ( LimTudo[1][0],X );
    LimTudo[1][1] = max ( LimTudo[1][1],Y );
    maximum = max ( maximum,M );
    minimum = min ( minimum,M );
  }
  fclose(T);
}

repega ( level )
real level;
{
  int X,Y;

  for (X=LimTudo[0][0];X<=LimTudo[1][0];X++)
    for (Y=LimTudo[0][1];Y<=LimTudo[1][1];Y++)
      if (proj[X][Y] >= level) pixel[X][Y] = FREE;
                        else   pixel[X][Y] = 0;
}

Peri_Area()
{
  int X,Y,P;

  Area = 0;
  Perimetro = 0;
  for(X=LimNuvem[0][0];X<=LimNuvem[1][0];X++)
    for(Y=LimNuvem[0][1];Y<=LimNuvem[1][1];Y++) {

	if (pixel[X][Y] == GOTTEN) {
	    Area++;
            pixel[X][Y] = AREA;
            P = 0;
	    if (pixel[X-1][Y] == 0) P++;
	    if (pixel[X+1][Y] == 0) P++;
	    if (pixel[X][Y-1] == 0) P++;
	    if (pixel[X][Y+1] == 0) P++;
	    Perimetro += P;
	  }
      }
}

PintaNuvem ( X,Y )
int X,Y;
{
  LimNuvem[0][0] = min(LimNuvem[0][0],X);
  LimNuvem[0][1] = min(LimNuvem[0][1],Y);
  LimNuvem[1][0] = max(LimNuvem[1][0],X);
  LimNuvem[1][1] = max(LimNuvem[1][1],Y);
  pixel[X][Y] = GOTTEN; 
  if (pixel[X-1][Y]==FREE)  PintaNuvem ( X-1,Y );
  if (pixel[X+1][Y]==FREE)  PintaNuvem ( X+1,Y );
  if (pixel[X][Y-1]==FREE)  PintaNuvem ( X,Y-1 );
  if (pixel[X][Y+1]==FREE)  PintaNuvem ( X,Y+1 );
}

int AchaNuvem ( X,Y )
int *X,*Y;
{
  int I;

  do {
    if (pixel[*X][*Y]==FREE) {
      for(I=0;I<=1;I++) { LimNuvem[0][I] = 32000; LimNuvem[1][I] = -32000; }
      PintaNuvem ( *X,*Y );
      return 1;
    }
    (*X)++;
    if ( *X > LimTudo[1][0] ) { (*Y)++; *X = LimTudo[0][0]; }
  } while ( *Y <= LimTudo[1][1] );

  return 0;
}

LoopPrincipal(level)
real level;
{
  int X,Y;

  repega(level);
  X = LimTudo[0][0];
  Y = LimTudo[0][1];
  while ( AchaNuvem ( &X,&Y )) {
      Peri_Area();
      if (Area>13) {
	fprintf(periarea,"%d %d\n",Area,Perimetro);
	NPontos++;
      }
    }
}

/*****************************************************************/
/**          main procedure                                     **/
/*****************************************************************/

main (argc,argv)
int argc;
char *argv[];
{
  char *i;
  real passo,nivel;

  if (argc < 2) { 
    printf("missing arguments: %s projection [output]\n",argv[0] );
    return;
  }

 Entrada = argv[1];
  if (argc > 2) Saida = argv[2]; else {
    strcpy ( Saida,Entrada );
    for (i=Saida; *i; i++) if (*i == '.') *i=0;
    strcat ( Saida, ".pa" );
  }

  printf("*** PeriArea ***\n");
  printf("%s -> %s\n",Entrada,Saida );

  LerDados(Entrada);
  passo = (maximum-minimum) / 10;
 
  if (argc == 2)  periarea = fopen ( Saida,"w" ); else
                  periarea = fopen ( Saida,"a" );

  for (nivel=minimum+passo; nivel<=maximum; nivel += passo)
    LoopPrincipal(nivel);

  fclose ( periarea );

  printf("%s updated with %d points.\n",Saida,NPontos);

}

